%% Envia uma mensagem  um socket conectado no contexto especificado
%
% O comando consiste em enviar primeiramente um
%
%         AT^SISW=<contexto>,<numero_de_bytes_a_serem_enviados>
%
% e aguardar a resposta do mdulo.
%
% A resposta do mdulo  a seguinte
%
%         ^SISW=<contexto>,<numero_de_bytes_a_serem_enviados>
%
% Aps isso, entramos com a mensagem a ser enviada

function dados = Envia_dados(obj_serial,mensagem,contexto)

global conectado;
global modulo_aguardando_dados;
global tempo_pausa;
tam = size(mensagem,2);
comando = ['at^sisw=' contexto ',' num2str(tam)];

while true

	imp(['Enviando o comando:' comando],0)
	Envia_cmd(obj_serial,comando);
    % Como no temos controle das mensagens que o mdulo ir retornar, qualquer
    % mensagem pode chegar a qualquer momento. Uma mensagem em particular  a
    % mensagem de encerramento de conexo. Porm, como o mdulo provavelmente
    % est aguardando os dados para o envio da mensagem, setamos a varivel
    % a seguir. Assim, indicamos  funo recebe_retorno que caso chegue
    % uma mensagem de encerramento de conexo, no  para fazer nada com
    % ela, e em seguida deve-se voltar a aguardar a mensagem
    modulo_aguardando_dados = true;
    cod = 0;
	while cod ~= 45
        [dados,cod] = Recebe_retorno(obj_serial);
		if cod == 10 || cod == 50
			imp(['Cdigo de erro ' num2str(cod) ' obtido. Saindo da funo Envia_dados.'],1)
			modulo_aguardando_dados = false;
			dados = '';
			return;
		end
	end
    modulo_aguardando_dados = false;
				
	% A resposta do mdulo possui o numero de bytes que podem ser
	% transmitidos. Com este valor, quebramos a mensagem em duas para que
	% consigamos transmit-la por inteiro
	num_char_tx = str2num(dados(10:size(dados,2)));
	num_char_restantes = size(mensagem,2) - num_char_tx;
	imp(['Numero de bytes a serem transmitidos: ' num2str(num_char_tx)],0)
	imp(['Numero de bytes que faltaram: ' num2str(num_char_restantes)],0)
				
    % Existem ocasies em que o mdulo est ocupado enviando outros bytes e
    % reponde que nenhum byte pode ser escrito. Se esta situao no
    % ocorrer, termina o lao...
	if num_char_tx ~= 0
		break
    % Agora, caso ela ocorra, aguarda uns instantes e tenta transmitir
    % novamente.
	else
		if ~conectado
			imp('Socket no conectado, saindo da funo Envia_dados.',1);
			return;
		end
		imp('Recebida resposta negativa, aguardando um momento',2)
		pause(1)
	end
end

% Envia a mensagem com o nmero de caracteres que o mdulo permitiu
imp(['Enviando a mensagem: ' mensagem(1:num_char_tx)],0)
fprintf(obj_serial,mensagem(1:num_char_tx));
if ~conectado
	imp('Socket no conectado, saindo da funo Envia_dados.',1);
	return;
end

[dados,cod] = Recebe_retorno(obj_serial);
if cod == 60
    imp('Parando a execuo do programa, saindo da funo Envia_dados',1)
    dados = 'q';
    return;
    % Seno, se chegou qualquer coisa diferente de OK
elseif cod ~= 0
	imp(['Mensagem de cdigo ' num2str(cod) ' recebida. Aguardando alguns instantes e reiniciando a aplicao.'],1)
	pause(tempo_pausa);
	dados = '';
    return;
end

imp('Aguardando a mensagem de socket pronto para receber mensagens',0)
[dados,cod] = Recebe_retorno(obj_serial);
if ~conectado
	imp('Socket no conectado, saindo da funo Envia_dados.',1);
	return;
end
if cod == 60
    imp('Parando a execuo do programa, saindo da funo Envia_dados',1)
    dados = 'q';
    return;
    % Seno, se chegou qualquer coisa diferente de OK
elseif cod ~= 40
	imp(['Mensagem de cdigo ' num2str(cod) ' recebida. Aguardando alguns instantes e reiniciando a aplicao.'],1)
	pause(tempo_pausa);
	dados = '';
    return;
end

% se ainda existirem informaes a serem transmitidas, chama recursivamente
% a funo envia_dados
if num_char_restantes ~= 0
	imp(['Enviando os ' num2str(num_char_restantes) ' bytes que o mdulo recusou'],0)
	dados = Envia_dados(obj_serial,mensagem(num_char_tx+1:size(mensagem,2)),contexto);
	if ~conectado
        imp('Socket no conectado, saindo da funo Envia_dados de nvel superior.',1)
        return;
	end
	if dados == 'q'
		imp('Saindo da funo Envia_dados de nvel superior',1)
		return;
	elseif isempty(dados)
		imp('Saindo da funo Envia_dados de nvel superior',1)
		return;
	end
end

dados = verifica_rejeita_cnx(obj_serial);
if dados == 'q'
	imp('Saindo da funo Envia_dados.',1)
	return;
elseif isempty(dados)
	imp('Saindo da funo Envia_dados.',1)
	return;
end