%% Recebe o retorno do mdulo, retornando o cdigo das mensagens
%
%  usado em vrias partes do programa, centralizando o recebimento das
% mensagens do mdulo.
function [dados,codigo_retorno] = Recebe_retorno(obj_serial)

global contexto_welcome_socket;
global contexto;
global conectado;
global modulo_aguardando_dados;
global contexto_a_rejeitar;

imp('Aguardando a resposta',0)
dados = '';
warning off;

% Conta quantas veses foi tentada a leitura da porta serial. Como o tempo
% mximo entre a entrada de um comando e seu retorno  de 15 minutos,
% deixaremos o dobro deste tempo como limite e retornaremos um valor que
% nenhuma das funes espera (100). Isto acarretar no reincio do
% servidor.
contador = 0;
while true
	
    % L uma linha da porta serial, concatenando com as outras j recebidas
    dado_tmp = fscanf(obj_serial);
    dados = [dados dado_tmp];
	contador = contador + 1;
	
    %----------------------------------------------------------------- OK
	% Testa se chegou a mensagem de retorno 'OK'
	try
		if strcmpi(dado_tmp(1:2),'OK')
			imp('OK encontrado na resposta a seguir:',0);
			imp(dados,0);
			codigo_retorno = 0;
			break;
		end
    end
	
    %----------------------------------------------------------------- ERRO
	% Testa se chegou a mensagem de retorno 'NO CARRIER'
	try
		if strcmpi(dado_tmp(1:2),'NO')
			imp('NO CARRIER encontrado na resposta a seguir:',1);
			imp(dados,0);
			imp('Tecle qualquer tecla para sair.',2);
			pause();
			codigo_retorno = 10;
			break;
		end
	end
	
	% Testa se chegou a mensagem de retorno 'ERROR'
	try
		if strcmpi(dado_tmp(1:5),'ERROR')
			imp('ERRO encontrado na resposta a seguir:',1);
			imp(dados,0)
			imp('Tecle qualquer tecla para sair.',2);
			pause();
			codigo_retorno = 10;
			break;
		end
	end
	
	% Testa se houve um erro, com mensagem de retorno '+CMS ERROR'
	try
		if strcmpi(dado_tmp(1:10),'+CMS ERROR')
			
			imp('ERRO encontrado na resposta a seguir:',1);
			imp(dados,1)
			imp('Tecle qualquer tecla para sair.',2);
			pause();
			codigo_retorno = 10;
			return;
		end
    end
	
    %----------------------------------------------------------------- SMS
	% Testa se o mdulo retornou a mensagem solicitando a entrada da
	% mensagem SMS
	try
		if strcmpi(dado_tmp(1),'>')

			imp('Recebida resposta:',0);
			imp(dados,0);
			codigo_retorno = 20;
			break;

		end
	end
	
	% Testa se o mdulo aceitou a gravao da mensagem SMS na memria
	try
		if strcmpi(dado_tmp(1:6),'+CMGW:')

			posicao = dado_tmp(8:size(dado_tmp,2));
			imp(['Mensagem salva na posio ' posicao],0)
			dados = posicao;
			codigo_retorno = 25;
			break;
			
		end
    end

    %--------------------------------------------------------------- Socket
	% Testa se chegou o pedido de conexo no contexto do Welcome Socket
	try
		if strcmpi(dado_tmp(1:10),['^SIS: ' contexto_welcome_socket ', 1'])
            imp('Recebida resposta:',0)
			imp(dados,0)
			% Se chegou o pedido, enquanto outro cliente est conectado
			if conectado
				contexto_a_rejeitar = dado_tmp(13);
				imp(['Recebido o pedido de conexo, direcionado ao contexto ' contexto_a_rejeitar],1)
				imp('A conexo ser rejeitada a seguir.',2)
			else
				dados = dado_tmp;
				codigo_retorno = 30;
				break;
			end
		end
	end
	
	% Testa se chegou a mensagem de encerramento de conexo no contexto
	try
		if strcmpi(dado_tmp(1:14),['^SIS: ' contexto ', 0, 47'])
            imp('Recebida resposta de encerramento da conexo:',1)
			imp(dados,0)
			conectado = false;
            codigo_retorno = 35;
            if modulo_aguardando_dados
                imp('A seguir o mdulo ir aguardar entrada de dados.',0)
                imp('Voltaremos a aguardar mensagens, sendo que em se-',0)
                imp('guida indicaremos o fim da conexo.',0)
            else
                imp('Retornando.',2)
                break;
            end
		end
	end
	
	% Testa se chegou a mensagem de socket pronto para ser escrito
	try
		if strcmpi(dado_tmp(1:11),['^SISW: ' contexto ', 1'])

			imp('Recebida resposta:',0)
			imp(dados,0);
			dados = dado_tmp;
			codigo_retorno = 40;
			break;
			
		end
	end

	% Testa se chegou a mensagem com o nmero de caracteres que podem ser
	% escritos
	try
		if strcmpi(dado_tmp(1:8),['^SISW: ' contexto])

			imp('Recebida resposta:',0)
			imp(dados,0);
			dados = dado_tmp;
			codigo_retorno = 45;
			break;
			
		end
    end

    %--------------------------------------------------------- Desligamento
	% Testa se o mdulo desligou
	try
		if strcmpi(dado_tmp(1:9),'^SHUTDOWN')
			imp('Recebida resposta:',0)
			imp(dados,0)
			codigo_retorno = 50;
			break;
		end
    end
	
    %----------------------------------------------------------------- Fim
	% Testa se o usurio apertou a tecla de parada indicando o fim da
	% execuo do programa
	if strcmpi(get(figure(1),'CurrentCharacter'),'q')
		set(figure(1),'CurrentCharacter','1');
		imp('Parando a execuo:',1)
		codigo_retorno = 60;
		break;
	end
	
	% Testa se o limite de tempo de leitura da serial foi atingido. Ao
	% retornar um valor que nenhuma das funes espera, foramos o reincio
	% da aplicao.
	if contador == 500
		imp('Atingido mximo tempo de leitura, reiniciando servidor',1)
		codigo_retorno = 100;
		break;
	end

end
